//########################
//IllustratorCS3で範囲選択します。
//選択メニューで塗りや線幅などがありますが、このスクリプトでは
//線幅0mm〜1mmや塗りC80〜C100など範囲を指定して選択できます。
//PowerPointなどのRGBPDFをIllustratorで開いて編集する時にリッチブラックになってしまった
//オブジェクトを一気に選択するために作りました。
//########################

var myAns = new Array();
var myPageItemSel = new Array();
var myPt = 1;
var myDocu = app.activeDocument;
main();
function main(){
	if (myDocu.length == 0){
		alert("ドキュメントを開いてください");
		return;
	}
	var myRU = myDocu.rulerUnits;
	if(myRU == RulerUnits.Centimeters){myPt = 28.3466796875;}
	else if(myRU == RulerUnits.Millimeters){myPt = 2.83466796875;}
	
	//ダイアログを作成する
	mydialog();
	if(myAns['cancel']){return;}
	select_pageitems_main();
	alert("終了しました。");
}

function mydialog(){
	var myDialog = new Window("dialog", "選択", [0,0,250,320]);
	myDialog.add("statictext",[5,5,240,20],"指定された範囲のオブジェクトを選択します");
	myDialog.f1 = myDialog.add("panel",[5,25,240,160],"線");
	myDialog.lineW = myDialog.f1.add("checkbox",[5,10,60,25],"線幅");
	myDialog.lineWs = myDialog.f1.add("edittext",[70,10,105,25],0);
	myDialog.f1.add("statictext",[110,10,145,25],"mm〜");
	myDialog.lineWe = myDialog.f1.add("edittext",[150,10,185,25],1);
	myDialog.f1.add("statictext",[190,10,220,25],"mm");
	
	myDialog.lineC1 = myDialog.f1.add("checkbox",[5,30,60,45],"線色");//radiobutton
	myDialog.lineC2 = myDialog.f1.add("checkbox",[5,110,60,120],"透明");
	myDialog.f1.add("statictext",[55,30,100,45],"C");
	myDialog.lineCs = myDialog.f1.add("edittext",[70,30,105,45],0);
	myDialog.f1.add("statictext",[110,30,145,45],"%〜");
	myDialog.lineCe = myDialog.f1.add("edittext",[150,30,185,45],0);
	myDialog.f1.add("statictext",[55,50,100,65],"M");
	myDialog.lineMs = myDialog.f1.add("edittext",[70,50,105,65],0);
	myDialog.f1.add("statictext",[110,50,145,65],"%〜");
	myDialog.lineMe = myDialog.f1.add("edittext",[150,50,185,65],0);
	myDialog.f1.add("statictext",[55,70,100,85],"Y");
	myDialog.lineYs = myDialog.f1.add("edittext",[70,70,105,85],0);
	myDialog.f1.add("statictext",[110,70,145,85],"%〜");
	myDialog.lineYe = myDialog.f1.add("edittext",[150,70,185,85],0);
	myDialog.f1.add("statictext",[55,90,100,105],"K");
	myDialog.lineKs = myDialog.f1.add("edittext",[70,90,105,105],0);
	myDialog.f1.add("statictext",[110,90,145,105],"%〜");
	myDialog.lineKe = myDialog.f1.add("edittext",[150,90,185,105],0);
	
	
	myDialog.f2 = myDialog.add("panel",[5,165,240,280],"塗り");
	
	myDialog.fillC1 = myDialog.f2.add("checkbox",[5,10,60,25],"塗色");
	myDialog.fillC2 = myDialog.f2.add("checkbox",[5,90,60,100],"透明");
	myDialog.f2.add("statictext",[55,10,100,25],"C");
	myDialog.fillCs = myDialog.f2.add("edittext",[70,10,105,25],0);
	myDialog.f2.add("statictext",[110,10,145,25],"%〜");
	myDialog.fillCe = myDialog.f2.add("edittext",[150,10,185,25],0);
	myDialog.f2.add("statictext",[55,30,100,45],"M");
	myDialog.fillMs = myDialog.f2.add("edittext",[70,30,105,45],0);
	myDialog.f2.add("statictext",[110,30,145,45],"%〜");
	myDialog.fillMe = myDialog.f2.add("edittext",[150,30,185,45],0);
	myDialog.f2.add("statictext",[55,50,100,65],"Y");
	myDialog.fillYs = myDialog.f2.add("edittext",[70,50,105,65],0);
	myDialog.f2.add("statictext",[110,50,145,65],"%〜");
	myDialog.fillYe = myDialog.f2.add("edittext",[150,50,185,65],0);
	myDialog.f2.add("statictext",[55,70,100,85],"K");
	myDialog.fillKs = myDialog.f2.add("edittext",[70,70,105,85],0);
	myDialog.f2.add("statictext",[110,70,145,85],"%〜");
	myDialog.fillKe = myDialog.f2.add("edittext",[150,70,185,85],0);
	

	//TOMBOを作る場合は下のコメント解除--★
	myDialog.ngBtn = myDialog.add("button",[60,285,150,305],"閉じる", { name:"cancel"});
	myDialog.okBtn = myDialog.add("button",[160,285,230,305],"選択", { name:"ok"});
	myDialog.center();
	//キャンセルボタンクリック時の動作
	//myDialog.show();の前に記述するのがコツ
	myDialog.ngBtn.onClick = function () {
		myAns['cancel'] = true;
		myDialog.close();
		return;
	}
	myDialog.okBtn.onClick = function () {
		var lineW = myDialog.lineW.value;
		myAns['lineWs'] = parseFloat(myDialog.lineWs.text)*myPt;
		myAns['lineWe'] = parseFloat(myDialog.lineWe.text)*myPt;
		if(myDialog.lineW.value){myAns['lineW']  = true;}else{myAns['lineW']  = false;}
		if(myDialog.lineC1.value){myAns['lineC1']  = true;}else{myAns['lineC1']  = false;}
		if(myDialog.lineC2.value){myAns['lineC2']  = true;}else{myAns['lineC2']  = false;}
		myAns['lineCs'] = parseFloat(myDialog.lineCs.text);
		myAns['lineCe'] = parseFloat(myDialog.lineCe.text);
		myAns['lineMs'] = parseFloat(myDialog.lineMs.text);
		myAns['lineMe'] = parseFloat(myDialog.lineMe.text);
		myAns['lineYs'] = parseFloat(myDialog.lineYs.text);
		myAns['lineYe'] = parseFloat(myDialog.lineYe.text);
		myAns['lineKs'] = parseFloat(myDialog.lineKs.text);
		myAns['lineKe'] = parseFloat(myDialog.lineKe.text);
		//myAns['xcount'] = parseInt(myDialog.xcount.text);
		if(myDialog.fillC1.value){myAns['fillC1']  = true;}else{myAns['fillC1']  = false;}
		if(myDialog.fillC2.value){myAns['fillC2']  = true;}else{myAns['fillC2']  = false;}
		myAns['fillCs'] = parseFloat(myDialog.fillCs.text);
		myAns['fillCe'] = parseFloat(myDialog.fillCe.text);
		myAns['fillMs'] = parseFloat(myDialog.fillMs.text);
		myAns['fillMe'] = parseFloat(myDialog.fillMe.text);
		myAns['fillYs'] = parseFloat(myDialog.fillYs.text);
		myAns['fillYe'] = parseFloat(myDialog.fillYe.text);
		myAns['fillKs'] = parseFloat(myDialog.fillKs.text);
		myAns['fillKe'] = parseFloat(myDialog.fillKe.text);
		myAns['cancel'] = false;
		myDialog.close();
		return;
	}
	myDialog.show();
}
function select_pageitems_main(){
	var pageitemcount = myDocu.pageItems.length;
	for(var N = 0;N < pageitemcount; N++){
		myPageItemSel[N] = true;
		var test = myDocu.pageItems[N];
		var mypageitem_type = myDocu.pageItems[N].typename;
		if(mypageitem_type == "GroupItem"){
			myPageItemSel[N] = false;
		}else if(mypageitem_type == "PathItem"){
			myPageItemSel[N] = select_pageitems_swich(myDocu.pageItems[N]);
		}else if(mypageitem_type == "TextFrame"){
			myPageItemSel[N] = select_pageitems_swich(myDocu.pageItems[N].paragraphs[0]);
		}else if(mypageitem_type == "CompoundPathItem"){
			myPageItemSel[N] = false;
		}else{
			myPageItemSel[N] = select_pageitems_swich(myDocu.pageItems[N]);
		}
		if(myPageItemSel[N]){
			myDocu.pageItems[N].selected = true;
		}
	}
}
function select_pageitems_swich(myObj){
	if(myAns['lineW']){
		if(select_pageItems_lineW(myObj) == false){
			return false;
		}	
	}
	if(myAns['lineC1']){
		if(select_pageItems_lineC1(myObj) == false){
			return false;
		}	
	}
	if(myAns['lineC2']){
		if(select_pageItems_lineC2(myObj) == false){
			return false;
		}	
	}
	if(myAns['fillC1']){
		if(select_pageItems_fillC1(myObj) == false){
			return false;
		}	
	}
	if(myAns['fillC2']){
		if(select_pageItems_fillC2(myObj) == false){
			return false;
		}	
	}
	return true;
}
function select_pageItems_lineW(myObj){
	try{
		var strokeW = myObj.strokeWidth;
		if(myObj.stroked == false || strokeW < myAns['lineWs'] || myAns['lineWe'] < strokeW){return false;}
		return true;
	}catch(err){
		return false;
	}
}
function select_pageItems_lineC1(myObj){
	try{
		var strokeCol = myObj.strokeColor;
		var strokeC = strokeCol.cyan;
		var strokeM = strokeCol.magenta;
		var strokeY = strokeCol.yellow;
		var strokeK = strokeCol.black;
		if(myObj.stroked == false){return false;}
		if(strokeC < myAns['lineCs'] || myAns['lineCe'] < strokeC){return false;}
		if(strokeM < myAns['lineMs'] || myAns['lineMe'] < strokeM){return false;}
		if(strokeY < myAns['lineYs'] || myAns['lineYe'] < strokeY){return false;}
		if(strokeK < myAns['lineKs'] || myAns['lineKe'] < strokeK){return false;}
		return true;
	}catch(err){
		return false;
	}
}
function select_pageItems_lineC2(myObj){
	try{
		if(myObj.stroked){return false;}
		return true;
	}catch(err){
		return false;
	}
}
function select_pageItems_fillC1(myObj){
	try{
		var fillCol = myObj.fillColor;
		var fillC = fillCol.cyan;
		var fillM = fillCol.magenta;
		var fillY = fillCol.yellow;
		var fillK = fillCol.black;
		if(myObj.filled == false){return false;}
		if(fillC < myAns['fillCs'] || myAns['fillCe'] < fillC){return false;}
		if(fillM < myAns['fillMs'] || myAns['fillMe'] < fillM){return false;}
		if(fillY < myAns['fillYs'] || myAns['fillYe'] < fillY){return false;}
		if(fillK < myAns['fillKs'] || myAns['fillKe'] < fillK){return false;}
		return true;
	}catch(err){
		return false;
	}
}
function select_pageItems_fillC2(myObj){
	try{
		if(myObj.filled){return false;}
		return true;
	}catch(err){
		return false;
	}
}